local Vector = require("libs.hump.vector")
local Movement = require("entities.parts.movement")
local Sprite = require("entities.parts.sprite")
local Fuse = require("entities.parts.fuse")
local Death = require("entities.parts.death")
local Entity = require("entities.entity")
local Bomb = Entity:extend("Bomb")

local super = Bomb.super
local image = load:image("etc/bomb.png", {255, 0, 255})
local g = Anim8.newGrid(32, 32, image:getDimensions())

function Bomb:init()
	super.init(self)

	-- Animation
	self.spriteData = {}
	self.spriteOffset = Vector.new(0, 0)
	self.image = image
	self.animation = Anim8.newAnimation(g("1-3", 1, 2, 1), 0.25)

	-- World
	self.owner = nil
	self.minimapIcon = nil

	-- Hitbox
	self.radius = 0.25
	self.collidesWith = {
		Unit = true
	}

	-- Bomb Things
	self.fuse = 3
	self.power = 1

	-- Components
	self:attach("movement", Movement:new())
	self:attach("sprite", Sprite:new())
	self:attach("fuse", Fuse:new())
	self:attach("death", Death:new())
end

return Bomb
