local Vector = require("libs.hump.vector")
local Movement = require("entities.parts.movement")
local Sprite = require("entities.parts.sprite")
local OO = require("entities.parts.oo")
local Death = require("entities.parts.death")
local StayInFront = require("entities.parts.stayinfront")
local Entity = require("entities.entity")
local BombGhost = Entity:extend("BombGhost")

local super = BombGhost.super
local image = load:image("etc/bomb_ghost.png", {255, 0, 255})

function BombGhost:init()
	super.init(self)

	-- Sprite
	self.spriteOffset = Vector.new(0, 0)
	self.image = image

	-- World
	self.owner = nil
	self.minimapIcon = {0, 0, 0, 0}

	-- Components
	self:attach("movement", Movement:new())
	self:attach("sprite", Sprite:new())
	self:attach("oo", OO:new())
	self:attach("death", Death:new())
	self:attach("stayinfront", StayInFront:new())
end

return BombGhost
