local Vector = require("libs.hump.vector")
local Movement = require("entities.parts.movement")
local Sprite = require("entities.parts.sprite")
local Entity = require("entities.entity")
local Corpse = Entity:extend("Corpse")

local super = Corpse.super
local sprites = {
	load:image("players/white-dead.png", {255, 0, 255}),
	load:image("players/black-dead.png", {255, 0, 255}),
	load:image("players/blue-dead.png", {255, 0, 255}),
	load:image("players/red-dead.png", {255, 0, 255})
}
local g = Anim8.newGrid(32, 32, sprites[1]:getDimensions())

function Corpse:init()
	super.init(self)

	-- Animation
	self.spriteData = {}
	self.spriteOffset = Vector.new(0, 2)
	self.image = nil
	self.animation = Anim8.newAnimation(g("1-4", 1), 0.2, "pauseAtEnd")

	-- World
	self.minimapIcon = nil

	-- Components
	self:attach("movement", Movement:new())
	self:attach("sprite", Sprite:new())
end

function Corpse:setID(id)
	if(id < 1 and id > #sprites) then return end
	self.image = sprites[id]
end

return Corpse
