local Component = require("entities.component")
local AnimFlow = Component:extend("Animation Flow Component")

function AnimFlow:init()
	self.currentAnim = nil
	self.lastAnim = nil
	self.currentFrame = 1
end

function AnimFlow:update(dt)
	local entity = self.entity
	if(entity.animation) then
		self.lastAnim = self.currentAnim
		self.currentAnim = entity.animation
		
		if(self.lastAnim ~= nil) then
			self.currentFrame = self.lastAnim.position
		end
	
		if(self.currentAnim ~= self.lastAnim) then
			self.currentAnim:gotoFrame(self.currentFrame)
		end

		if(entity.speed:len2() <= 0) then
			self.currentFrame = 1
		end
	end
end

return AnimFlow
