local Component = require("entities.component")
local Death = Component:extend("Death Component")

function Death:init()
	self.lastUpdate = true
end

function Death:onAttach()
	local entity = self.entity

	entity.alive = true
	self.lastUpdate = entity.alive
end

function Death:onDetach()
	local entity = self.entity

	entity.alive = nil
end

function Death:update(dt)
	local entity = self.entity
	local map = entity.map

	if(not entity.alive and self.lastUpdate) then
		if(entity.onDeath) then entity:onDeath() end
		map:removeEntity(entity.id)
	end
	self.lastUpdate = entity.alive
end

return Death
