local Corpse = require("entities.corpse")
local Component = require("entities.component")
local DropCorpse = Component:extend("Drop Corpse Component")

function DropCorpse:onAttach()
	local entity = self.entity

	entity.onDeath = self.drop
end

function DropCorpse:onDetach()
	local entity = self.entity

	entity.onDeath = nil
end

function DropCorpse:drop()
	local map = self.map
	local corpse = Corpse:new()
	corpse:setID(self.playerID)
	corpse:setPosition(self.position:unpack())
	map:spawn(corpse)
end

return DropCorpse
