local Component = require("entities.component")
local OwnerOnlySprite = Component:extend("Owner Only Sprite Component")

function OwnerOnlySprite:init()
	self.visibleBy = {}
end

function OwnerOnlySprite:onAttach()
	local entity = self.entity

	entity.visibleBy = self.visibleBy
	entity.visibleTo = self.visibleTo
end

function OwnerOnlySprite:onDetach()
	local entity = self.entity

	entity.visibleBy = nil
	entity.visibleTo = nil
end

function OwnerOnlySprite:update(dt)
	local entity = self.entity
	entity.visibleBy[entity.owner.id] = true
end

function OwnerOnlySprite:visibleTo(unitID)
	return self.visibleBy[unitID]
end

return OwnerOnlySprite
