local Component = require("entities.component")
local Sprite = Component:extend("Raycastable Sprite Component")

function Sprite:update(dt)
	if(self.entity.animation) then
		self.entity.animation:update(dt)
	end
end

function Sprite:draw(debug)
	local e = self.entity
	local d = e.spriteData
	local o = -e.spriteOffset
	local defaultColor = nil
	if(e.colorize) then
		defaultColor = {love.graphics.getColor()}
		love.graphics.setColor(e.colorize)
	end
	if(e.animation) then
		e.animation:draw(e.image, d.x, d.y, 0,
						 d.sx, d.sy, o.x, o.y)
	elseif(e.animation == nil and e.image) then
		love.graphics.draw(e.image, d.x, d.y, 0,
						   d.sx, d.sy, o.x, o.y)
	end
	if(defaultColor) then love.graphics.setColor(defaultColor) end
end

return Sprite
