local Component = require("entities.component")
local StayInFront = Component:extend("Stay-in-Front Behavior Component")

local floor, cos, sin = math.floor, math.cos, math.sin

function StayInFront:update(dt)
	local entity = self.entity
	local owner = entity.owner
	local map = entity.map

	if(owner ~= nil) then
		local x = floor(owner.position.x + cos(owner.rotation))
		local y = floor(owner.position.y + sin(owner.rotation))
		entity:setPosition(x + 0.5, y + 0.5)
	end
end

return StayInFront
