local Component = require("entities.component")
local ViewBob = Component:extend("View Bob Component")

local cos = math.cos

function ViewBob:init()
	self.defaultHeight = 0
	self.bob = 0
end

function ViewBob:onAttach()
	local entity = self.entity

	self.defaultHeight = entity.eyeHeight
end

function ViewBob:onDetach()
	local entity = self.entity

	entity.eyeHeight = self.defaultHeight
end

function ViewBob:update(dt)
	local entity = self.entity

	if(entity.speed:len2() > 0) then
		self.bob = self.bob + dt * entity.speed:normalized():len()
	end

	entity.eyeHeight = self.defaultHeight + cos(self.bob * 10) / 100
end

return ViewBob
