local Game = {}

local game = nil

function Game:init()
	print("Game: Initializing...")

	print("Game: -- END Init --")
end

function Game:enter(from, ...)
	print("Game: Entering...")
	local args = {...}
	game = unpack(args)
end

function Game:update(dt)
	game.map:updateSpawner(dt)
	game.map:updateEntities(dt)
	game.map:castRays()
end

function Game:draw()
	game.map:drawFloor()
	game.map:drawRaycast()
	-- game.map:drawMinimap(0, 0)
end

function Game:keypressed(key, isRepeat)
	Beholder.trigger("keypress", key)
end

function Game:keyreleased(key)
	Beholder.trigger("keyrelease", key)
end

Beholder.observe("keypress", function(key)
	if(key == "w") then
		game.map.raycaster.unit.speed.y = 1
	elseif(key == "s") then
		game.map.raycaster.unit.speed.y = -1
	end
	if(key == "a") then
		game.map.raycaster.unit.speed.x = -1
	elseif(key == "d") then
		game.map.raycaster.unit.speed.x = 1
	end
	if(key == "left") then
		game.map.raycaster.unit.look = -1
	elseif(key == "right") then
		game.map.raycaster.unit.look = 1
	end
	if(key == " ") then
		game.map.raycaster.unit:setGhost()
	end
	if(key == "k") then
		game.map.raycaster.unit.alive = false
	end
	if(key == "l") then
		local unit = game.map.raycaster.unit
		game.map.raycaster.unit = (unit ~= game.player) and
							   game.player or game.player2
	end
	-- if(key == "escape") then
	-- 	ProFi:stop()
	-- 	ProFi:writeReport()
	-- end
end)

Beholder.observe("keyrelease", function(key)
	if(key == "w" or key == "s") then
		game.map.raycaster.unit.speed.y = 0
	elseif(key == "a" or key == "d") then
		game.map.raycaster.unit.speed.x = 0
	elseif(key == "left" or key == "right") then
		game.map.raycaster.unit.look = 0
	end
	if(key == " ") then
		game.map.raycaster.unit:setBomb()
	end
end)

return Game
