local Map = require("entities.map")
local Unit = require("entities.unit")
local Bomb = require("entities.bomb")
local Raycaster = require("entities.raycaster")
local Spawner = require("entities.spawner")
local InitGame = {}

local game = {}

function InitGame:init()
	print("InitGame: -- Initializing --")

	print("InitGame: -- END Init --")
end

function InitGame:enter(from, ...)
	print("InitGame: -- Entering...")

	game.map = Map.fromJSON(load:file("maps/blank.json"))
	game.map.floorLayer = 1
	game.map.raycastLayer = 2
	game.map.minimapScale = 8
	game.map:initFloor()
	game.map:generateSoftBricks(0.4)

	local x = game.map.misc["1"].x + 0.5
	local y = game.map.misc["1"].y + 0.5
	game.player = Unit:new()
	game.player:setPosition(x, y)
	game.player:setID(1)

	local x = game.map.misc["2"].x + 0.5
	local y = game.map.misc["2"].y + 0.5
	game.player2 = Unit:new()
	game.player2:setPosition(x, y)
	game.player2:setID(2)
	game.player2.rotation = math.rad(180)

	game.map.raycaster = Raycaster:new(game.map)
	game.map.raycaster.unit = game.player
	game.map.raycaster:initRaycaster()

	game.map.spawner = Spawner:new(game.map)
	game.map:spawnAll(game.player, game.player2)

	GS.switch(require("states.game"), game)
end

function InitGame:leave()
	print("InitGame: -- Leaving...")
end

return InitGame
